searchData={"content_type":"text/markdown","items":[{"doc":"A simple wrapper to run GPG commands.\n\nTested on Linux with `gpg (GnuPG) 2.2.27`.\n\n> #","ref":"GPGex.html","title":"GPGex","type":"module"},{"doc":">\n> This is a pre-release version. As such, anything _may_ change at any time, the public\n> API _should not_ be considered stable, and using a pinned version is _recommended_.","ref":"GPGex.html#module-warning-warning","title":"Warning {: .warning} - GPGex","type":"module"},{"doc":"You can configure the library with both the `global_keystore` key in the configuration\nand the `keystore` option in functions.\n\nThe `keystore` option in functions takes precedence over the `global_keystore` configuration,\nand if none of these are provided, your default GPG keystore (i.e. \"homedir\") will be used.\n\nYou can specify an optional directory to be passed to `--homedir`, and an optional filename\nto be passed to `--keyring` (in which case `--no-default-keyring` will be automatically added).\n\n    config :gpg_ex,\n      global_keystore: %{\n        path: \"priv/global_gpg_homedir\",\n        keyring: \"global_gpg_keyring.kbx\"\n      }\n\n_Note: the following configuration is used in the \"Examples\" section throughout this documentation:_\n\n    config :gpg_ex,\n      global_keystore: %{\n        path: \"/tmp/gpg_ex_keystore\"\n      }","ref":"GPGex.html#module-configuration","title":"Configuration - GPGex","type":"module"},{"doc":"Runs GPG with the given args.\n\nReturns parsed status messages and stdout rows separately in a tuple.\n\nAlso returns the command arguments if it failed.\n\nSee [gnupg/doc/DETAILS](https://github.com/gpg/gnupg/blob/master/doc/DETAILS#format-of-the-status-fd-output)\nfor a full list and description of statuses and their arguments.","ref":"GPGex.html#cmd/2","title":"GPGex.cmd/2","type":"function"},{"doc":"* `:keystore` - a `GPGex.Keystore` struct.","ref":"GPGex.html#cmd/2-options","title":"Options - GPGex.cmd/2","type":"function"},{"doc":"iex> {:ok, messages, stdout} = GPGex.cmd([\"--recv-keys\", \"18D5DCA13E5D61587F552A1BDEB5A837B34DD01D\"])\n    iex> messages\n    [\n      \"KEY_CONSIDERED 18D5DCA13E5D61587F552A1BDEB5A837B34DD01D 0\",\n      \"IMPORTED DEB5A837B34DD01D GPGEx Test  \",\n      \"IMPORT_OK 1 18D5DCA13E5D61587F552A1BDEB5A837B34DD01D\",\n      \"IMPORT_RES 1 0 1 0 0 0 0 0 0 0 0 0 0 0 0\"\n    ]\n    iex> stdout\n    [\n      \"key DEB5A837B34DD01D: public key \\\"GPGEx Test  \\\" imported\",\n      \"Total number processed: 1\",\n      \"imported: 1\"\n    ]\n\n    iex> GPGex.cmd([\"--delete-keys\", \"18D5DCA13E5D61587F552A1BDEB5A837B34DD01D\"])\n    {:ok, [], []}\n\n    iex> GPGex.cmd([\"--recv-keys\", \"91C8AFC4674BF0963E7A90CEB7FFBE9D2DF23D67\"])\n    {:error,\n      [\"FAILURE recv-keys 167772218\"],\n      [\"keyserver receive failed: No data\"],\n      [\"--homedir\", \"/tmp/gpg_ex_keystore\", \"--batch\", \"--status-fd=1\", \"--recv-keys\", \"91C8AFC4674BF0963E7A90CEB7FFBE9D2DF23D67\"]\n    }","ref":"GPGex.html#cmd/2-examples","title":"Examples - GPGex.cmd/2","type":"function"},{"doc":"Same as `cmd/1` but raises a `RuntimeError` if the command fails.","ref":"GPGex.html#cmd!/2","title":"GPGex.cmd!/2","type":"function"},{"doc":"iex> GPGex.cmd!([\"--unknown-option\"])\n    ** (RuntimeError) GPG command 'gpg --homedir /tmp/gpg_ex_keystore --batch --status-fd=1 --unknown-option' failed with:\n    invalid option \"--unknown-option\"\n\n    iex> {_, _} = GPGex.cmd!([\"--recv-keys\", \"18D5DCA13E5D61587F552A1BDEB5A837B34DD01D\"])","ref":"GPGex.html#cmd!/2-examples","title":"Examples - GPGex.cmd!/2","type":"function"},{"doc":"Functions for managing GPG keystores.","ref":"GPGex.Keystore.html","title":"GPGex.Keystore","type":"module"},{"doc":"Ensures the specified GPG keystore is initialized and\nreturns a struct to use with `GPGex` functions.","ref":"GPGex.Keystore.html#get_keystore/1","title":"GPGex.Keystore.get_keystore/1","type":"function"},{"doc":"* `:path` - the GPG homedir to use, defaults to `$GNUPGHOME || \"~/.gnupg\"`\n  * `:keyring` - the keyring filename, defaults to `nil` (uses GPG's default)","ref":"GPGex.Keystore.html#get_keystore/1-options","title":"Options - GPGex.Keystore.get_keystore/1","type":"function"},{"doc":"Get the default keystore:\n\n    iex> GPGex.Keystore.get_keystore()\n\n  Get (and maybe create) a keystore in a specific location:\n\n    iex> keystore = GPGex.Keystore.get_keystore(path: \"/tmp/test_keystore\", keyring: \"pubring_2.kbx\")\n    %GPGex.Keystore{path: \"/tmp/test_keystore\", keyring: \"pubring_2.kbx\"}\n    iex> {:ok, _, _} = GPGex.cmd(\n    ...>    [\"--recv-keys\", \"18D5DCA13E5D61587F552A1BDEB5A837B34DD01D\"],\n    ...>    keystore: keystore\n    ...>  )","ref":"GPGex.Keystore.html#get_keystore/1-examples","title":"Examples - GPGex.Keystore.get_keystore/1","type":"function"},{"doc":"Calls `get_keystore/2` with the global keystore options from `Config`.\n\nReturns `nil` if the `Config` is not set.","ref":"GPGex.Keystore.html#get_keystore_global/0","title":"GPGex.Keystore.get_keystore_global/0","type":"function"},{"doc":"Get the globally configured keystore:\n\n    iex> GPGex.Keystore.get_keystore_global()\n    %GPGex.Keystore{path: \"/tmp/gpg_ex_keystore\", keyring: nil}","ref":"GPGex.Keystore.html#get_keystore_global/0-examples","title":"Examples - GPGex.Keystore.get_keystore_global/0","type":"function"},{"doc":"Calls `get_keystore/2` with a writable temporary directory.","ref":"GPGex.Keystore.html#get_keystore_temp/0","title":"GPGex.Keystore.get_keystore_temp/0","type":"function"},{"doc":"An abstraction on top of GPG's `homedir` and `keyring`\nto hold references to private and public keys locations.","ref":"GPGex.Keystore.html#t:t/0","title":"GPGex.Keystore.t/0","type":"type"},{"doc":"# GPGex\n\nA simple wrapper to run GPG commands.\n\nTested on Linux with `gpg (GnuPG) 2.2.27`.\n\n> [!WARNING]  \n> This is a pre-release version. As such, anything _may_ change\n> at any time, the public API _should not_ be considered stable,\n> and using a pinned version is _recommended_.","ref":"readme.html","title":"GPGex","type":"extras"},{"doc":"This library relies on `gpg` being available in your PATH.\n\nThe package can be installed by adding `gpg_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:gpg_ex, \"1.0.0-alpha.3\"}\n  ]\nend\n```\n\nFull documentation can be found at [https://hexdocs.pm/gpg_ex](https://hexdocs.pm/gpg_ex).","ref":"readme.html#installation","title":"Installation - GPGex","type":"extras"},{"doc":"This project follows the principles of [Semantic Versioning (SemVer)](https://semver.org/).","ref":"readme.html#versioning","title":"Versioning - GPGex","type":"extras"},{"doc":"# Changelog\n\n## [1.0.0-alpha.3](https://github.com/sheerlox/gpg_ex/compare/v1.0.0-alpha.2...v1.0.0-alpha.3) (2023-11-26)\n\n\n#","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* update dependency semantic-release-hex to v1.1.1 ([322426a](https://github.com/sheerlox/gpg_ex/commit/322426a675e2173b6d2b318f01fbc17180358003))\n\n## [1.0.0-alpha.2](https://github.com/sheerlox/gpg_ex/compare/v1.0.0-alpha.1...v1.0.0-alpha.2) (2023-11-26)\n\n\n#","ref":"changelog.html#builds","title":"🛠 Builds - Changelog","type":"extras"},{"doc":"* removed `gpg_home` config key in favor of `global_keystore`\n* `cmd/2` now returns command arguments on error\n\n#","ref":"changelog.html#breaking-changes","title":"⚠ Breaking changes - Changelog","type":"extras"},{"doc":"* add `Keystore` module ([#1](https://github.com/sheerlox/gpg_ex/issues/1)) ([07580d2](https://github.com/sheerlox/gpg_ex/commit/07580d21f21061097e1e132a612f0a45c914ebd1))","ref":"changelog.html#features","title":"✨ Features - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#1-0-0-alpha-1-2023-11-25","title":"1.0.0-alpha.1 (2023-11-25) - Changelog","type":"extras"},{"doc":"* add `cmd/1` & `cmd!/1` to run GPG commands ([5a2f129](https://github.com/sheerlox/gpg_ex/commit/5a2f12937b01bb57a93d332d45a42d0f4b49892e))\n\n\n#","ref":"changelog.html#features","title":"✨ Features - Changelog","type":"extras"},{"doc":"* setup dialyzer & test matrix ([b5d2705](https://github.com/sheerlox/gpg_ex/commit/b5d2705dcdb4bbb6b4cfd3fcdca225aad7e59295))\n* setup semantic-release & ex_doc ([8fcdad2](https://github.com/sheerlox/gpg_ex/commit/8fcdad204adf2a12185e74236ae5673bdb73cbc4))\n\n\n#","ref":"changelog.html#continuous-integrations","title":"⚙️ Continuous Integrations - Changelog","type":"extras"},{"doc":"* initialize project ([6c522cc](https://github.com/sheerlox/gpg_ex/commit/6c522cc340f7a09e69822e9105bf953c8a916e3f))","ref":"changelog.html#chores","title":"♻️ Chores - Changelog","type":"extras"},{"doc":"# License\n\nCopyright (c) 2023 Pierre Cavin\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\nhttp://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html","title":"License","type":"extras"}]}